osgText::Text Class Reference

`#include <Text>`

Inheritance diagram for osgText::Text:

## Classes

struct | GlyphQuads

## Public Types

enum | BackdropType { DROP_SHADOW_BOTTOM_RIGHT = 0 , DROP_SHADOW_CENTER_RIGHT , DROP_SHADOW_TOP_RIGHT , DROP_SHADOW_BOTTOM_CENTER , DROP_SHADOW_TOP_CENTER , DROP_SHADOW_BOTTOM_LEFT , DROP_SHADOW_CENTER_LEFT , DROP_SHADOW_TOP_LEFT , OUTLINE , NONE }
enum | ColorGradientMode { SOLID = 0 , PER_CHARACTER , OVERALL }
enum | BackdropImplementation { POLYGON_OFFSET = 0 , NO_DEPTH_BUFFER , DEPTH_RANGE , STENCIL_BUFFER , DELAYED_DEPTH_WRITES }
typedef std::map< osg::ref_ptr< GlyphTexture >, GlyphQuads > | TextureGlyphQuadMap
Public Types inherited from osgText::TextBase
enum | CharacterSizeMode { OBJECT_COORDS , SCREEN_COORDS , OBJECT_COORDS_WITH_MAXIMUM_SCREEN_SIZE_CAPPED_BY_FONT_HEIGHT }
enum | AlignmentType { LEFT_TOP , LEFT_CENTER , LEFT_BOTTOM , CENTER_TOP , CENTER_CENTER , CENTER_BOTTOM , RIGHT_TOP , RIGHT_CENTER , RIGHT_BOTTOM , LEFT_BASE_LINE , CENTER_BASE_LINE , RIGHT_BASE_LINE , LEFT_BOTTOM_BASE_LINE , CENTER_BOTTOM_BASE_LINE , RIGHT_BOTTOM_BASE_LINE , BASE_LINE = LEFT_BASE_LINE }
enum | AxisAlignment { XY_PLANE , REVERSED_XY_PLANE , XZ_PLANE , REVERSED_XZ_PLANE , YZ_PLANE , REVERSED_YZ_PLANE , SCREEN , USER_DEFINED_ROTATION }
enum | Layout { LEFT_TO_RIGHT , RIGHT_TO_LEFT , VERTICAL }
enum | DrawModeMask { TEXT = 1 , BOUNDINGBOX = 2 , FILLEDBOUNDINGBOX = 4 , ALIGNMENT = 8 }
typedef osg::ref_ptr< osg::Vec3Array > | Coords
Public Types inherited from osg::Drawable

enum

AttributeTypes {
VERTICES = 0 , WEIGHTS = 1 , NORMALS = 2 , COLORS = 3 ,
SECONDARY_COLORS = 4 , FOG_COORDS = 5 , ATTRIBUTE_6 = 6 , ATTRIBUTE_7 = 7 ,
TEXTURE_COORDS = 8 , TEXTURE_COORDS_0 = TEXTURE_COORDS , TEXTURE_COORDS_1 = TEXTURE_COORDS_0+1 , TEXTURE_COORDS_2 = TEXTURE_COORDS_0+2 ,
TEXTURE_COORDS_3 = TEXTURE_COORDS_0+3 , TEXTURE_COORDS_4 = TEXTURE_COORDS_0+4 , TEXTURE_COORDS_5 = TEXTURE_COORDS_0+5 , TEXTURE_COORDS_6 = TEXTURE_COORDS_0+6 ,
TEXTURE_COORDS_7 = TEXTURE_COORDS_0+7
}

typedef DrawableUpdateCallback | UpdateCallback
typedef DrawableEventCallback | EventCallback
typedef DrawableCullCallback | CullCallback
typedef unsigned int | AttributeType
Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| Text ()
| Text (const Text &text, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
virtual osg::Object * | cloneType () const
virtual osg::Object * | clone (const osg::CopyOp &copyop) const
virtual bool | isSameKindAs (const osg::Object *obj) const
virtual const char * | className () const
virtual const char * | libraryName () const
void | setShaderTechnique (ShaderTechnique technique)
ShaderTechnique | getShaderTechnique ()
void | setEnableDepthWrites (bool enable)
bool | getEnableDepthWrites () const
void | setBackdropType (BackdropType type)
BackdropType | getBackdropType () const
void | setBackdropOffset (float offset=0.07f)
void | setBackdropOffset (float horizontal, float vertical)
float | getBackdropHorizontalOffset () const
float | getBackdropVerticalOffset () const
void | setBackdropColor (const osg::Vec4 &color)
const osg::Vec4 & | getBackdropColor () const
void | setColorGradientMode (ColorGradientMode mode)
ColorGradientMode | getColorGradientMode () const
void | setColorGradientCorners (const osg::Vec4 &topLeft, const osg::Vec4 &bottomLeft, const osg::Vec4 &bottomRight, const osg::Vec4 &topRight)
const osg::Vec4 & | getColorGradientTopLeft () const
const osg::Vec4 & | getColorGradientBottomLeft () const
const osg::Vec4 & | getColorGradientBottomRight () const
const osg::Vec4 & | getColorGradientTopRight () const
virtual void | drawImplementation (osg::RenderInfo &renderInfo) const
virtual bool | supports (const osg::Drawable::AttributeFunctor &) const
virtual bool | supports (const osg::Drawable::ConstAttributeFunctor &) const
virtual void | accept (osg::Drawable::ConstAttributeFunctor &af) const
virtual bool | supports (const osg::PrimitiveFunctor &) const
virtual void | accept (osg::PrimitiveFunctor &pf) const
bool | getCharacterCorners (unsigned int index, osg::Vec3 &bottomLeft, osg::Vec3 &bottomRight, osg::Vec3 &topLeft, osg::Vec3 &topRight) const
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *state=0) const
void | setBackdropImplementation (BackdropImplementation)
BackdropImplementation | getBackdropImplementation () const
const GlyphQuads * | getGlyphQuads (GlyphTexture *texture) const
const TextureGlyphQuadMap & | getTextureGlyphQuadMap () const
void | addGlyphQuad (Glyph *glyph, const osg::Vec2 &minc, const osg::Vec2 &maxc, const osg::Vec2 &mintc, const osg::Vec2 &maxtc)
Public Member Functions inherited from osgText::TextBase
| TextBase ()
| TextBase (const TextBase &text, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
void | setColor (const osg::Vec4 &color)
const osg::Vec4 & | getColor () const
virtual void | setFont (Font *font=0)
virtual void | setFont (osg::ref_ptr< Font > font)
virtual void | setFont (const std::string &fontfile)
Font * | getFont ()
const Font * | getFont () const
void | setStyle (Style *style)
Style * | getStyle ()
const Style * | getStyle () const
Style * | getOrCreateStyle ()
void | setFontResolution (unsigned int width, unsigned int height)
unsigned int | getFontWidth () const
unsigned int | getFontHeight () const
void | setText (const String &text)
void | setText (const std::string &text)
void | setText (const std::string &text, String::Encoding encoding)
void | setText (const wchar_t *text)
String & | getText ()
const String & | getText () const
void | update ()
void | setCharacterSize (float height)
void | setCharacterSize (float height, float aspectRatio)
float | getCharacterHeight () const
float | getCharacterAspectRatio () const
void | setCharacterSizeMode (CharacterSizeMode mode)
CharacterSizeMode | getCharacterSizeMode () const
void | setMaximumWidth (float maximumWidth)
float | getMaximumWidth () const
void | setMaximumHeight (float maximumHeight)
float | getMaximumHeight () const
void | setLineSpacing (float lineSpacing)
float | getLineSpacing () const
void | setPosition (const osg::Vec3 &pos)
const osg::Vec3 & | getPosition () const
void | setAlignment (AlignmentType alignment)
AlignmentType | getAlignment () const
void | setAxisAlignment (AxisAlignment axis)
AxisAlignment | getAxisAlignment () const
void | setRotation (const osg::Quat &quat)
const osg::Quat & | getRotation () const
void | setAutoRotateToScreen (bool autoRotateToScreen)
bool | getAutoRotateToScreen () const
void | setLayout (Layout layout)
Layout | getLayout () const
void | setDrawMode (unsigned int mode)
unsigned int | getDrawMode () const
void | setBoundingBoxMargin (float margin)
float | getBoundingBoxMargin () const
void | setBoundingBoxColor (const osg::Vec4 &color)
const osg::Vec4 & | getBoundingBoxColor () const
void | setKerningType (KerningType kerningType)
KerningType | getKerningType () const
unsigned int | getLineCount () const
virtual void | compileGLObjects (osg::RenderInfo &renderInfo) const
virtual osg::BoundingBox | computeBoundingBox () const
Coords & | getCoords ()
const Coords & | getCoords () const
void | getCoord (unsigned int i, osg::Vec2 &c) const
void | getCoord (unsigned int i, osg::Vec3 &c) const
const osg::Matrix & | getMatrix () const
bool | computeMatrix (osg::Matrix &matrix, osg::State *state=0) const
Public Member Functions inherited from osg::Drawable
| Drawable ()
| Drawable (const Drawable &drawable, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Drawable)
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual void | computeDataVariance ()
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setInitialBound (const osg::BoundingBox &bbox)
const BoundingBox & | getInitialBound () const
const BoundingSphere & | getBound () const
const BoundingBox & | getBoundingBox () const
virtual BoundingSphere | computeBound () const
void | setComputeBoundingBoxCallback (ComputeBoundingBoxCallback *callback)
ComputeBoundingBoxCallback * | getComputeBoundingBoxCallback ()
const ComputeBoundingBoxCallback * | getComputeBoundingBoxCallback () const
virtual void | setShape (Shape *shape)
template<class T>
void | setShape (const ref_ptr< T > &shape)
Shape * | getShape ()
const Shape * | getShape () const
void | setSupportsDisplayList (bool flag)
bool | getSupportsDisplayList () const
void | setUseDisplayList (bool flag)
bool | getUseDisplayList () const
GLuint & | getDisplayList (unsigned int contextID) const
virtual void | setUseVertexBufferObjects (bool flag)
bool | getUseVertexBufferObjects () const
void | setUseVertexArrayObject (bool flag)
bool | getUseVertexArrayObject () const
virtual void | dirtyGLObjects ()
virtual unsigned int | getGLObjectSizeHint () const
void | draw (RenderInfo &renderInfo) const
void | drawInner (RenderInfo &renderInfo) const
void | setCreateVertexArrayStateCallback (CreateVertexArrayStateCallback *cb)
CreateVertexArrayStateCallback * | getCreateVertexArrayStateCallback ()
const CreateVertexArrayStateCallback * | getCreateVertexArrayStateCallback () const
VertexArrayState * | createVertexArrayState (RenderInfo &renderInfo) const
void | setVertexArrayStateList (VertexArrayStateList &vasl)
VertexArrayStateList & | getVertexArrayStateList ()
const VertexArrayStateList & | getVertexArrayStateList () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setDrawCallback (DrawCallback *dc)
DrawCallback * | getDrawCallback ()
const DrawCallback * | getDrawCallback () const
virtual void | accept (AttributeFunctor &)
virtual bool | supports (const PrimitiveIndexFunctor &) const
virtual void | accept (PrimitiveIndexFunctor &) const
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | accept (NodeVisitor &nv)
virtual void | ascend (NodeVisitor &nv)
virtual void | traverse (NodeVisitor &)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~Text ()
virtual osg::StateSet * | createStateSet ()
Font * | getActiveFont ()
String::iterator | computeLastCharacterOnLine (osg::Vec2 &cursor, String::iterator first, String::iterator last)
void | computeGlyphRepresentation ()
bool | computeAverageGlyphWidthAndHeight (float &avg_width, float &avg_height) const
virtual void | computePositionsImplementation ()
void | computeColorGradients ()
void | computeColorGradientsOverall ()
void | computeColorGradientsPerCharacter ()
void | drawImplementation (osg::State &state, const osg::Vec4 &colorMultiplier) const
void | drawImplementationSinglePass (osg::State &state, const osg::Vec4 &colorMultiplier) const
float | bilinearInterpolate (float x1, float x2, float y1, float y2, float x, float y, float q11, float q12, float q21, float q22) const
Protected Member Functions inherited from osgText::TextBase
virtual | ~TextBase ()
virtual void | assignStateSet ()
void | initArraysAndBuffers ()
osg::VertexArrayState * | createVertexArrayStateImplementation (osg::RenderInfo &renderInfo) const
void | positionCursor (const osg::Vec2 &endOfLine_coords, osg::Vec2 &cursor, unsigned int linelength)
String::iterator | computeLastCharacterOnLine (osg::Vec2 &cursor, String::iterator first, String::iterator last)
void | computePositions ()
void | setupDecoration ()
unsigned int | addCoord (const osg::Vec2 &c)
unsigned int | addCoord (const osg::Vec3 &c)
void | addTexCoord (const osg::Vec2 &tc)
Protected Member Functions inherited from osg::Drawable
Drawable & | operator= (const Drawable &)
virtual | ~Drawable ()
void | setBound (const BoundingBox &bb) const
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

TextureGlyphQuadMap | _textureGlyphQuadMap
ShaderTechnique | _shaderTechnique
bool | _enableDepthWrites
BackdropType | _backdropType
float | _backdropHorizontalOffset
float | _backdropVerticalOffset
osg::Vec4 | _backdropColor
ColorGradientMode | _colorGradientMode
osg::Vec4 | _colorGradientTopLeft
osg::Vec4 | _colorGradientBottomLeft
osg::Vec4 | _colorGradientBottomRight
osg::Vec4 | _colorGradientTopRight
Protected Attributes inherited from osgText::TextBase
osg::Vec4 | _color
osg::ref_ptr< Font > | _font
osg::ref_ptr< Font > | _fontFallback
osg::ref_ptr< Style > | _style
FontResolution | _fontSize
float | _characterHeight
CharacterSizeMode | _characterSizeMode
float | _maximumWidth
float | _maximumHeight
float | _lineSpacing
String | _text
osg::Vec3 | _position
AlignmentType | _alignment
AxisAlignment | _axisAlignment
osg::Quat | _rotation
bool | _autoRotateToScreen
Layout | _layout
unsigned int | _drawMode
float | _textBBMargin
osg::Vec4 | _textBBColor
KerningType | _kerningType
unsigned int | _lineCount
bool | _glyphNormalized
osg::Vec3 | _offset
osg::Vec3 | _normal
osg::BoundingBox | _textBB
osg::BoundingBox | _textBBWithMargin
osg::Matrix | _matrix
Primitives | _decorationPrimitives
osg::ref_ptr< osg::VertexBufferObject > | _vbo
osg::ref_ptr< osg::ElementBufferObject > | _ebo
Coords | _coords
Coords | _normals
ColorCoords | _colorCoords
TexCoords | _texcoords
Protected Attributes inherited from osg::Drawable
BoundingBox | _initialBoundingBox
ref_ptr< ComputeBoundingBoxCallback > | _computeBoundingBoxCallback
BoundingBox | _boundingBox
ref_ptr< Shape > | _shape
bool | _supportsDisplayList
bool | _useDisplayList
bool | _supportsVertexBufferObjects
bool | _useVertexBufferObjects
bool | _useVertexArrayObject
GLObjectList | _globjList
VertexArrayStateList | _vertexArrayStateList
ref_ptr< DrawCallback > | _drawCallback
ref_ptr< CreateVertexArrayStateCallback > | _createVertexArrayStateCallback
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Drawable
static GLuint | generateDisplayList (unsigned int contextID, unsigned int sizeHint=0)
static void | deleteDisplayList (unsigned int contextID, GLuint globj, unsigned int sizeHint=0)
static void | setMinimumNumberOfDisplayListsToRetainInCache (unsigned int minimum)
static unsigned int | getMinimumNumberOfDisplayListsToRetainInCache ()
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Types inherited from osgText::TextBase
typedef osg::ref_ptr< osg::Vec2Array > | TexCoords
typedef osg::ref_ptr< osg::Vec4Array > | ColorCoords
typedef std::vector< osg::ref_ptr< osg::DrawElements > > | Primitives
Protected Types inherited from osg::Drawable
typedef osg::buffered_value< GLuint > | GLObjectList

## Member Typedef Documentation

## TextureGlyphQuadMap

typedef std::map<osg::ref_ptr<GlyphTexture>,GlyphQuads> osgText::Text::TextureGlyphQuadMap

## Member Enumeration Documentation

## BackdropImplementation

enum osgText::Text::BackdropImplementation

deprecated, value ignored.

Enumerator
POLYGON_OFFSET |
NO_DEPTH_BUFFER |
DEPTH_RANGE |
STENCIL_BUFFER |
DELAYED_DEPTH_WRITES |

## BackdropType

enum osgText::Text::BackdropType

Enumerator
DROP_SHADOW_BOTTOM_RIGHT |
DROP_SHADOW_CENTER_RIGHT |
DROP_SHADOW_TOP_RIGHT |
DROP_SHADOW_BOTTOM_CENTER |
DROP_SHADOW_TOP_CENTER |
DROP_SHADOW_BOTTOM_LEFT |
DROP_SHADOW_CENTER_LEFT |
DROP_SHADOW_TOP_LEFT |
OUTLINE |
NONE |

## ColorGradientMode

enum osgText::Text::ColorGradientMode

Enumerator
SOLID |
PER_CHARACTER |
OVERALL |

## Constructor & Destructor Documentation

## Text() [1/2]

osgText::Text::Text | ( |  | ) |

Referenced by clone(), cloneType(), osgText::FadeText::FadeText(), isSameKindAs(), and Text().

## Text() [2/2]

osgText::Text::Text | ( | const Text & | text,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

References osg::CopyOp::SHALLOW_COPY, and Text().

## ~Text()

virtual osgText::Text::~Text | ( |  | ) |

protected virtual

## Member Function Documentation

## accept() [1/2]

virtual void osgText::Text::accept | ( | osg::Drawable::ConstAttributeFunctor & | af | ) | const

virtual

accept an ConstAttributeFunctor and call its methods to tell it about the internal attributes that this Drawable has.

Reimplemented from osg::Drawable.

## accept() [2/2]

virtual void osgText::Text::accept | ( | osg::PrimitiveFunctor & | pf | ) | const

virtual

accept a PrimtiveFunctor and call its methods to tell it about the internal primitives that this Drawable has.

Reimplemented from osg::Drawable.

## addGlyphQuad()

void osgText::Text::addGlyphQuad | ( | Glyph * | glyph,
|  | const osg::Vec2 & | minc,
|  | const osg::Vec2 & | maxc,
|  | const osg::Vec2 & | mintc,
|  | const osg::Vec2 & | maxtc )

## bilinearInterpolate()

float osgText::Text::bilinearInterpolate | ( | float | x1,
|  | float | x2,
|  | float | y1,
|  | float | y2,
|  | float | x,
|  | float | y,
|  | float | q11,
|  | float | q12,
|  | float | q21,
|  | float | q22 ) const

protected

## className()

virtual const char * osgText::Text::className | ( |  | ) | const

inline virtual

return the name of the node's class type.

Reimplemented from osgText::TextBase.

## clone()

virtual osg::Object * osgText::Text::clone | ( | const osg::CopyOp & | copyop | ) | const

inline virtual

return a clone of a node, with Object* return type.

Reimplemented from osg::Node.

References Text().

## cloneType()

virtual osg::Object * osgText::Text::cloneType | ( |  | ) | const

inline virtual

clone an object of the same type as the node.

Reimplemented from osg::Node.

References Text().

## computeAverageGlyphWidthAndHeight()

bool osgText::Text::computeAverageGlyphWidthAndHeight | ( | float & | avg_width,
|  | float & | avg_height ) const

protected

## computeColorGradients()

void osgText::Text::computeColorGradients | ( |  | ) |

protected

## computeColorGradientsOverall()

void osgText::Text::computeColorGradientsOverall | ( |  | ) |

protected

## computeColorGradientsPerCharacter()

void osgText::Text::computeColorGradientsPerCharacter | ( |  | ) |

protected

## computeGlyphRepresentation()

void osgText::Text::computeGlyphRepresentation | ( |  | ) |

protected virtual

Implements osgText::TextBase.

## computeLastCharacterOnLine()

String::iterator osgText::Text::computeLastCharacterOnLine | ( | osg::Vec2 & | cursor,
|  | String::iterator | first,
|  | String::iterator | last )

protected

## computePositionsImplementation()

virtual void osgText::Text::computePositionsImplementation | ( |  | ) |

protected virtual

Reimplemented from osgText::TextBase.

## createStateSet()

virtual osg::StateSet * osgText::Text::createStateSet | ( |  | ) |

protected virtual

Reimplemented from osgText::TextBase.

## drawImplementation() [1/2]

virtual void osgText::Text::drawImplementation | ( | osg::RenderInfo & | renderInfo | ) | const

virtual

Draw the text.

Reimplemented from osg::Drawable.

Reimplemented in osgText::FadeText.

## drawImplementation() [2/2]

void osgText::Text::drawImplementation | ( | osg::State & | state,
|  | const osg::Vec4 & | colorMultiplier ) const

protected

## drawImplementationSinglePass()

void osgText::Text::drawImplementationSinglePass | ( | osg::State & | state,
|  | const osg::Vec4 & | colorMultiplier ) const

protected

## getActiveFont()

Font * osgText::Text::getActiveFont | ( |  | ) |

protected

## getBackdropColor()

const osg::Vec4 & osgText::Text::getBackdropColor | ( |  | ) | const

inline

References _backdropColor.

## getBackdropHorizontalOffset()

float osgText::Text::getBackdropHorizontalOffset | ( |  | ) | const

inline

References _backdropHorizontalOffset.

## getBackdropImplementation()

BackdropImplementation osgText::Text::getBackdropImplementation | ( |  | ) | const

inline

deprecated, value should be ignored.

References DELAYED_DEPTH_WRITES.

## getBackdropType()

BackdropType osgText::Text::getBackdropType | ( |  | ) | const

inline

References _backdropType.

## getBackdropVerticalOffset()

float osgText::Text::getBackdropVerticalOffset | ( |  | ) | const

inline

References _backdropVerticalOffset.

## getCharacterCorners()

bool osgText::Text::getCharacterCorners | ( | unsigned int | index,
|  | osg::Vec3 & | bottomLeft,
|  | osg::Vec3 & | bottomRight,
|  | osg::Vec3 & | topLeft,
|  | osg::Vec3 & | topRight ) const

Get the coordinates of the character corners in local coordinates. Use Text::getMatrix() or Text::computeMatrix(..) to get the transform into model coordinates (see TextBase header.)

## getColorGradientBottomLeft()

const osg::Vec4 & osgText::Text::getColorGradientBottomLeft | ( |  | ) | const

inline

References _colorGradientBottomLeft.

## getColorGradientBottomRight()

const osg::Vec4 & osgText::Text::getColorGradientBottomRight | ( |  | ) | const

inline

References _colorGradientBottomRight.

## getColorGradientMode()

ColorGradientMode osgText::Text::getColorGradientMode | ( |  | ) | const

inline

References _colorGradientMode.

## getColorGradientTopLeft()

const osg::Vec4 & osgText::Text::getColorGradientTopLeft | ( |  | ) | const

inline

References _colorGradientTopLeft.

## getColorGradientTopRight()

const osg::Vec4 & osgText::Text::getColorGradientTopRight | ( |  | ) | const

inline

References _colorGradientTopRight.

## getEnableDepthWrites()

bool osgText::Text::getEnableDepthWrites | ( |  | ) | const

inline

References _enableDepthWrites.

## getGlyphQuads()

const GlyphQuads * osgText::Text::getGlyphQuads | ( | GlyphTexture * | texture | ) | const

inline

Direct Access to GlyphQuads

References _textureGlyphQuadMap, and NULL.

## getShaderTechnique()

ShaderTechnique osgText::Text::getShaderTechnique | ( |  | ) |

inline

Get the ShaderTechnique hint.

References _shaderTechnique.

## getTextureGlyphQuadMap()

const TextureGlyphQuadMap & osgText::Text::getTextureGlyphQuadMap | ( |  | ) | const

inline

References _textureGlyphQuadMap.

## isSameKindAs()

virtual bool osgText::Text::isSameKindAs | ( | const osg::Object * | obj | ) | const

inline virtual

return true if this and obj are of the same kind of object.

Reimplemented from osgText::TextBase.

References NULL, and Text().

## libraryName()

virtual const char * osgText::Text::libraryName | ( |  | ) | const

inline virtual

return the name of the node's library.

Reimplemented from osgText::TextBase.

## releaseGLObjects()

virtual void osgText::Text::releaseGLObjects | ( | osg::State * | state = 0 | ) | const

virtual

If State is non-zero, this function releases OpenGL objects for the specified graphics context. Otherwise, releases OpenGL objexts for all graphics contexts.

Reimplemented from osgText::TextBase.

## resizeGLObjectBuffers()

virtual void osgText::Text::resizeGLObjectBuffers | ( | unsigned int | maxSize | ) |

virtual

Resize any per context GLObject buffers to specified size.

Reimplemented from osgText::TextBase.

## setBackdropColor()

void osgText::Text::setBackdropColor | ( | const osg::Vec4 & | color | ) |

This specifies the color of the backdrop text. The default is black.

## setBackdropImplementation()

void osgText::Text::setBackdropImplementation | ( | BackdropImplementation |  | ) |

inline

deprecated, value ignored.

## setBackdropOffset() [1/2]

void osgText::Text::setBackdropOffset | ( | float | horizontal,
|  | float | vertical )

This overloaded version lets you specify the offset for the horizontal and vertical components separately.

## setBackdropOffset() [2/2]

void osgText::Text::setBackdropOffset | ( | float | offset = 0.07f | ) |

Sets the amount text is offset to create the backdrop/shadow effect. Set the value too high and for example, in OUTLINE mode you will get a "Brady Bunch" effect where you see duplicates of the text in a 3x3 grid. Set the value too small and you won't see anything. The values represent percentages. 1.0 means 100% so a value of 1.0 in DROW_SHADOW_LEFT_CENTER mode would cause each glyph to be echoed next to it self. So the letter 'e' might look like 'ee'. Good values tend to be in the 0.03 to 0.10 range (but will be subject to your specific font and display characteristics). Note that the text bounding boxes are updated to include backdrop offsets. However, other metric information such as getCharacterHeight() are unaffected by this. This means that individual glyph spacing (kerning?) are unchanged even when this mode is used. The default is 0.07 (7% offset).

## setBackdropType()

void osgText::Text::setBackdropType | ( | BackdropType | type | ) |

BackdropType gives you a background shadow text behind your regular text. This helps give text extra contrast which can be useful when placing text against noisy backgrounds. The color of the background shadow text is specified by setBackdropColor(). DROP_SHADOW_BOTTOM_RIGHT will draw backdrop text to the right and down of the normal text. Other DROP_SHADOW_* modes do the same for their respective directions. OUTLINE will draw backdrop text so that it appears the text has an outline or border around the normal text. This mode is particularly useful against really noisy backgrounds that may put text on top of things that have all types of colors which you don't have control over. Some real world examples of this general technique in use that I know of are Google Earth, Sid Meier's Pirates (2004 Remake), and Star Control 2 (PC 1993). The default is NONE.

## setColorGradientCorners()

void osgText::Text::setColorGradientCorners | ( | const osg::Vec4 & | topLeft,
|  | const osg::Vec4 & | bottomLeft,
|  | const osg::Vec4 & | bottomRight,
|  | const osg::Vec4 & | topRight )

Used only for gradient mode, let's you specify the colors of the 4 corners. If ColorGradients are off, these values are ignored (and the value from setColor() is the only one that is relevant.

## setColorGradientMode()

void osgText::Text::setColorGradientMode | ( | ColorGradientMode | mode | ) |

This sets different types of text coloring modes. When the coloring mode is not set to SOLID, the colors specified in setColorGradientCorners() determine the colors for the text. When the gradient mode is OVERALL, the coloring scheme attempts to approximate the effect as if the entire text box/region were a single polygon and you had applied colors to each of the four corners with GL_SMOOTH enabled. In this mode, OpenGL interpolates the colors across the polygon, and this is what OVERALL tries to emulate. This can be used to give nice embellishments on things like logos and names. PER_CHARACTER is similar to OVERALL except that it applies the color interpolation to the four corners of each character instead of across the overall text box. The default is SOLID (a.k.a. off).

## setEnableDepthWrites()

void osgText::Text::setEnableDepthWrites | ( | bool | enable | ) |

inline

Turns off writing to the depth buffer when rendering text. This only affects text with no backdrop or text using the DELAYED_DEPTH_WRITES implementation, since the other backdrop implementations are really only useful for backwards compatibility and are not worth updating to utilize this flag.

References _enableDepthWrites.

## setShaderTechnique()

void osgText::Text::setShaderTechnique | ( | ShaderTechnique | technique | ) |

Set the ShaderTechnique hint to specify what fatures in the text shaders to enable.

## supports() [1/3]

virtual bool osgText::Text::supports | ( | const osg::Drawable::AttributeFunctor & |  | ) | const

inline virtual

return false, osgText::Text does not support accept(AttributeFunctor&).

Reimplemented from osg::Drawable.

## supports() [2/3]

virtual bool osgText::Text::supports | ( | const osg::Drawable::ConstAttributeFunctor & |  | ) | const

inline virtual

return true, osgText::Text does support accept(ConstAttributeFunctor&).

Reimplemented from osg::Drawable.

## supports() [3/3]

virtual bool osgText::Text::supports | ( | const osg::PrimitiveFunctor & |  | ) | const

inline virtual

return true, osgText::Text does support accept(PrimitiveFunctor&) .

Reimplemented from osg::Drawable.

## Member Data Documentation

## _backdropColor

osg::Vec4 osgText::Text::_backdropColor

protected

Referenced by getBackdropColor().

## _backdropHorizontalOffset

float osgText::Text::_backdropHorizontalOffset

protected

Referenced by getBackdropHorizontalOffset().

## _backdropType

BackdropType osgText::Text::_backdropType

protected

Referenced by getBackdropType().

## _backdropVerticalOffset

float osgText::Text::_backdropVerticalOffset

protected

Referenced by getBackdropVerticalOffset().

## _colorGradientBottomLeft

osg::Vec4 osgText::Text::_colorGradientBottomLeft

protected

Referenced by getColorGradientBottomLeft().

## _colorGradientBottomRight

osg::Vec4 osgText::Text::_colorGradientBottomRight

protected

Referenced by getColorGradientBottomRight().

## _colorGradientMode

ColorGradientMode osgText::Text::_colorGradientMode

protected

Referenced by getColorGradientMode().

## _colorGradientTopLeft

osg::Vec4 osgText::Text::_colorGradientTopLeft

protected

Referenced by getColorGradientTopLeft().

## _colorGradientTopRight

osg::Vec4 osgText::Text::_colorGradientTopRight

protected

Referenced by getColorGradientTopRight().

## _enableDepthWrites

bool osgText::Text::_enableDepthWrites

protected

Referenced by getEnableDepthWrites(), and setEnableDepthWrites().

## _shaderTechnique

ShaderTechnique osgText::Text::_shaderTechnique

protected

Referenced by getShaderTechnique().

## _textureGlyphQuadMap

TextureGlyphQuadMap osgText::Text::_textureGlyphQuadMap

protected

Referenced by getGlyphQuads(), and getTextureGlyphQuadMap().

The documentation for this class was generated from the following file:

- Text